//
//   PDF2y[W1y[Wɂē܂萻{ł悤ɂvO
//      by K.Miki   2014/06/21 (from PDF2on1)
//

import java.io.*;
import java.io.File;
import java.awt.event.*;
import javax.swing.filechooser.*;
import javax.swing.*;
import java.awt.*;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import com.itextpdf.text.Document;
import com.itextpdf.text.Rectangle;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfImportedPage;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfWriter;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import java.util.*;

public class PDFmbk extends JFrame implements ActionListener{
  static JButton button1, button2;
  static JTextField tfw;
  static JTextArea ta;
  static String fpath, cwidth;
  static File cpath = new File("");
  static JProgressBar pbar = new JProgressBar(1, 100);
  static JRadioButton rbone = new JRadioButton("Ж", true);
  static JRadioButton rbtwo = new JRadioButton("");
  static JRadioButton rbleft = new JRadioButton("Ԃ", true);
  static JRadioButton rbright = new JRadioButton("EԂ");
  static int fn=0;
  static File[] flist = new File[100];

  public static void main(String[] args) {
    PDFmbk frame = new PDFmbk();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setBounds(10, 10, 360, 300);
    frame.setTitle("PDF make Book");
    DropTarget dtarget = new DropTarget(button1,new dtAdapter());
	frame.setVisible(true);
  }

  // Drag & Dropւ̑Ή
  private static class dtAdapter extends DropTargetAdapter {
	 public void drop(DropTargetDropEvent dtde) {
        try {
           Transferable trans = dtde.getTransferable();
           DataFlavor flavors[] = trans.getTransferDataFlavors();
           for (int i = 0; i < flavors.length; ++i)
              if (flavors[i].isFlavorJavaFileListType()) {
				 dtde.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);
                 java.util.List list = (java.util.List) trans.getTransferData(flavors[i]);
                 for (int j = 0; j < list.size(); ++j) {
                    flist[fn] = (File) list.get(j);
					ta.setText(ta.getText()+flist[fn++].getAbsolutePath()+"\n");
                 }
              }
        } catch (IOException ioe) {
	       ioe.printStackTrace();
        } catch (UnsupportedFlavorException ufe) {
           ufe.printStackTrace();
        } finally {
           dtde.dropComplete(true);
        }
     }
  }
  
  // ݒWindow̕\
  PDFmbk(){
    getContentPane().setLayout(new GridLayout(6,1));

    button1=new JButton("t@CJ (܂͂Drug & Drop)");
    button1.addActionListener(this);
    getContentPane().add(button1);

	ta=new JTextArea("", 64,10);
    ta.setWrapStyleWord(true);
	ta.setLineWrap(false);
	JScrollPane scrollPane = new JScrollPane(ta);
	scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	scrollPane.setPreferredSize(new Dimension(200, 100));
	getContentPane().add(scrollPane);
	
	Panel p3=new Panel();
    p3.setLayout(new GridLayout(1,3));
    JLabel lab3=new JLabel("@@̕");
	p3.add(lab3);
	Panel p31=new Panel();
    p31.setLayout(new GridLayout(1,2));
	ButtonGroup bg = new ButtonGroup();
	bg.add(rbone);bg.add(rbtwo);
	p31.add(rbone);p31.add(rbtwo);
	p3.add(p31);
    getContentPane().add(p3);

	Panel p4=new Panel();
    p4.setLayout(new GridLayout(1,3));
    JLabel lab4=new JLabel("@@Ԃ");
	p4.add(lab4);
	Panel p41=new Panel();
    p41.setLayout(new GridLayout(1,2));
	ButtonGroup bg2 = new ButtonGroup();
	bg2.add(rbleft);bg2.add(rbright);
	p41.add(rbleft);p41.add(rbright);
	p4.add(p41);
    getContentPane().add(p4);

	Panel p6=new Panel();
    p6.setLayout(new FlowLayout());
    button2=new JButton("쐬");
    button2.addActionListener(this);
    button2.setPreferredSize(new Dimension(220,40));
	p6.add(button2);
    getContentPane().add(p6);
	
	Panel p5=new Panel();
    p5.setLayout(new FlowLayout());
	JLabel lab5=new JLabel("   ver. 1.00  by K.Miki 2014/06/21");
	pbar.setValue(0);
    pbar.setPreferredSize(new Dimension(120,30));
	p5.add(pbar);p5.add(lab5);
    getContentPane().add(p5);
  }
  
  // Progress Barreset
  static void resetpbar(int n){
     pbar.setMaximum(n);pbar.setValue(0);pbar.paintImmediately(pbar.getVisibleRect());
  }

  // ۂ̎dƂ iText̃Tv()炾ԕςȂB
  
  static void twoOnOne(String sname) {
  	 int n,i,fp=0;
	 float width,off1,off2;
	 Document document;
	 
     try {
        PdfReader reader = new PdfReader(flist[fp++].getAbsolutePath());
        n=reader.getNumberOfPages();
        Rectangle psize = reader.getPageSize(1);
		width=psize.getWidth();
		if (rbleft.isSelected()) {
			off1=0;off2=width;
		} else {
			off2=0;off1=width;
		}
		document=new Document(new Rectangle(width*2, psize.getHeight()));
        PdfWriter writer=PdfWriter.getInstance(document,new FileOutputStream(sname));
        document.open();
        PdfContentByte cb = writer.getDirectContent();
		resetpbar(n);
        for (i=0;i<n;) {
           document.newPage();
           i++;pbar.setValue(i);pbar.paintImmediately(pbar.getVisibleRect());
           PdfImportedPage page1 = writer.getImportedPage(reader, i);
           cb.addTemplate(page1, 1, 0, 0, 1, off1, 0);
		   if (i==n && fp<fn) {
		   	  reader = new PdfReader(flist[fp++].getAbsolutePath());
              n=reader.getNumberOfPages();
			  resetpbar(n);
			  i=0;
		   }
           if (i < n) {
              i++;pbar.setValue(i);pbar.paintImmediately(pbar.getVisibleRect());
              PdfImportedPage page2 = writer.getImportedPage(reader, i);
              cb.addTemplate(page2, 1, 0, 0, 1, off2, 0);
		      if (i==n && fp<fn) {
		   	     reader = new PdfReader(flist[fp++].getAbsolutePath());
                 n=reader.getNumberOfPages();
				 resetpbar(n);
				 i=0;
		      }
           }
        }
        document.close();
     } catch (Exception de) {
            de.printStackTrace();
     }
  }

    // ʈΉ
    static void twoOnTwo(String sname) {
  	 int n,i,j,fp=0;
	 float width,off1,off2;
	 Document document;
	 PdfImportedPage page[] = new PdfImportedPage[4];
	 
     try {
        PdfReader reader = new PdfReader(flist[fp++].getAbsolutePath());
        n=reader.getNumberOfPages();
        Rectangle psize = reader.getPageSize(1);
        width = psize.getWidth();
		if (rbleft.isSelected()) {
			off1=0;off2=width;
		} else {
			off2=0;off1=width;
		}
		document=new Document(new Rectangle(width*2, psize.getHeight()));
        PdfWriter writer=PdfWriter.getInstance(document,new FileOutputStream(sname));
        document.open();
        PdfContentByte cb = writer.getDirectContent();
		resetpbar(n);
        for (i=0;i<n;) {
			for (j=0;j<4;j++) {
                if (i<n) page[j] = writer.getImportedPage(reader, ++i);
				else     page[j]=null;
		        if (i==n && fp<fn) {
		   	       reader = new PdfReader(flist[fp++].getAbsolutePath());
                   n=reader.getNumberOfPages();
			       resetpbar(n);
			       i=0;
		        }
			 }
           document.newPage();
           pbar.setValue(i);pbar.paintImmediately(pbar.getVisibleRect());
           if (page[3]!=null)
              cb.addTemplate(page[3], 1, 0, 0, 1, off1, 0);
           if (page[0]!=null)
              cb.addTemplate(page[0], 1, 0, 0, 1, off2, 0);
           document.newPage();
		   if (page[1]!=null)
              cb.addTemplate(page[1], 1, 0, 0, 1, off1, 0);
           if (page[2]!=null)
              cb.addTemplate(page[2], 1, 0, 0, 1, off2, 0);
        }
        document.close();
     } catch (Exception de) {
            de.printStackTrace();
     }
  }

  //  ut@CJv{^ւ̑Ή
  public void actionPerformed(ActionEvent e){
     if (e.getSource().equals(button1)) { /* t@CJ */
	 	JFileChooser fchooser;
        if (cpath.getPath().equals("")) fchooser = new JFileChooser();
		else                            fchooser = new JFileChooser(cpath);
        javax.swing.filechooser.FileFilter filter1=new FileNameExtensionFilter("PDF document (*.pdf)","pdf");
        fchooser.addChoosableFileFilter(filter1);
        if (fchooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION){
		   cpath=fchooser.getCurrentDirectory();
           flist[fn] = fchooser.getSelectedFile();
		   ta.setText(ta.getText()+flist[fn++].getAbsolutePath()+"\n");
        }
    } else if (e.getSource().equals(button2) && fn>0) { /* 쐬 */
       // ۑ߂
  	   String fname=flist[0].getAbsolutePath();
	   String sfix;
  	   File ofile,pfile;
  	   int i;
	
	   ofile=new File(fname);
	   if (ofile.getParent()==null)
	      fname=(new File(".").getAbsoluteFile().getParent())+File.separator+fname;
	   ofile=new File(fname);
	   if (rbone.isSelected())
	       if (rbleft.isSelected()) sfix="SL.pdf";
		   else                     sfix="SR.pdf";
	   else
	       if (rbleft.isSelected()) sfix="DL.pdf";
		   else                     sfix="DR.pdf";
	   while (ofile.exists()) {
	      i=fname.lastIndexOf(".pdf");
	      fname=fname.substring(0,i)+sfix;
	      ofile=new File(fname);
	   }
	   if (rbone.isSelected()) twoOnOne(fname);
	   else                    twoOnTwo(fname);
    }
  }
  
}
